package cz.muni.fi.pa165.socialnetwork.aop;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;

@Component
@Aspect
public class LoggingAspect {
    @Around("@annotation(cz.muni.fi.pa165.socialnetwork.anotation.MethodExecutionTimeTracker)")
    public Object trackMethodInvocationTime(ProceedingJoinPoint joinPoint){
        String currentTime = new SimpleDateFormat("yyyy.MM.dd.HH.mm.ss").format(new java.util.Date());
        System.out.println(currentTime);
        Object obj = null;
        try{
            obj = joinPoint.proceed();
        }catch (Throwable e){

        }
        System.out.println(joinPoint.getSignature().toLongString());
        System.out.println(currentTime);
        return obj;
    }
}
