package cz.muni.fi.pa165.socialnetwork.rest;

import cz.muni.fi.pa165.socialnetwork.api.PersonBasicViewDto;
import cz.muni.fi.pa165.socialnetwork.api.PersonDetailedViewDto;
import cz.muni.fi.pa165.socialnetwork.facade.PersonFacade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping(path = "/persons")
public class PersonRestController {

    private final PersonFacade personFacade;

    @Autowired
    public PersonRestController(PersonFacade personFacade) {
        this.personFacade = personFacade;
    }

    @GetMapping(path = "/{id}")
    public ResponseEntity<PersonDetailedViewDto> findById(@PathVariable("id") Long id) {
        return ResponseEntity.ok(personFacade.findById(id));
    }

    @GetMapping
    public Page<PersonBasicViewDto> findAll(Pageable pageable) {
        return personFacade.findAll(pageable);
    }
}
